Gecode::Int::Extensional::Compact< View, pos >::ValidSupports Class Reference

Iterator over valid supports. More...

`#include <extensional.hh>`

## Public Member Functions

| ValidSupports (const Compact< View, pos > &p, CTAdvisor &a)
| Initialize from initialized propagator.
| ValidSupports (const TupleSet &ts, int i, View x)
| Initialize during initialization.
void | operator++ (void)
| Move to next supports.
bool | operator() (void) const
| Whether there are still supports left.
const BitSetData * | supports (void) const
| Return supports.
int | val (void) const
| Return supported value.

## Protected Member Functions

void | find (void)
| Find a new value (only for negative case).

## Protected Attributes

const unsigned int | n_words
| Number of words.
int | max
| Maximal value.
ViewRanges< View > | xr
| Range iterator.
const Range * | sr
| Support iterator.
const Range * | lst
| The last range.
int | n
| The value.
const BitSetData * | s
| The value's support.

## Detailed Description

template<class View, bool pos>
class Gecode::Int::Extensional::Compact< View, pos >::ValidSupports

Iterator over valid supports.

Definition at line 397 of file extensional.hh.

## Constructor & Destructor Documentation

## ValidSupports() [1/2]

template<class View, bool pos>

Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::ValidSupports | ( | const Compact< View, pos > & | p,
|  | CTAdvisor & | a )

inline

Initialize from initialized propagator.

Definition at line 209 of file compact.hpp.

## ValidSupports() [2/2]

template<class View, bool pos>

Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::ValidSupports | ( | const TupleSet & | ts,
|  | int | i,
|  | View | x )

inline

Initialize during initialization.

Definition at line 224 of file compact.hpp.

## Member Function Documentation

## find()

template<class View, bool pos>

void Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::find | ( | void |  | ) |

inline protected

Find a new value (only for negative case).

Definition at line 179 of file compact.hpp.

## operator++()

template<class View, bool pos>

void Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::operator++ | ( | void |  | ) |

inline

Move to next supports.

Definition at line 239 of file compact.hpp.

## operator()()

template<class View, bool pos>

bool Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::operator() | ( | void |  | ) | const

inline

Whether there are still supports left.

Definition at line 266 of file compact.hpp.

## supports()

template<class View, bool pos>

const BitSetData * Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::supports | ( | void |  | ) | const

inline

Return supports.

Definition at line 271 of file compact.hpp.

## val()

template<class View, bool pos>

int Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::val | ( | void |  | ) | const

inline

Return supported value.

Definition at line 277 of file compact.hpp.

## Member Data Documentation

## n_words

template<class View, bool pos>

const unsigned int Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::n_words

protected

Number of words.

Definition at line 400 of file extensional.hh.

## max

template<class View, bool pos>

int Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::max

protected

Maximal value.

Definition at line 402 of file extensional.hh.

## xr

template<class View, bool pos>

ViewRanges<View> Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::xr

protected

Range iterator.

Definition at line 404 of file extensional.hh.

## sr

template<class View, bool pos>

const Range* Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::sr

protected

Support iterator.

Definition at line 406 of file extensional.hh.

## lst

template<class View, bool pos>

const Range* Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::lst

protected

The last range.

Definition at line 408 of file extensional.hh.

## n

template<class View, bool pos>

int Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::n

protected

The value.

Definition at line 410 of file extensional.hh.

## s

template<class View, bool pos>

const BitSetData* Gecode::Int::Extensional::Compact< View, pos >::ValidSupports::s

protected

The value's support.

Definition at line 412 of file extensional.hh.

The documentation for this class was generated from the following files:

- gecode/int/extensional.hh
- gecode/int/extensional/compact.hpp